<template>
    <div
        v-if="data && shop"
        class="page-container"
    >
        <div class="video-button-container">
            <VideoButton :source="'https://carti.crisp.help/en/article/enable-push-cart-abandonment-automation-1bbsep9/reader'" />
        </div>
        <div class="index__info">
            Get your customers to complete their purchases with our Abandoned Cart Push Notifications! Only sent to those on
            your subscriber list, started checkout but did not complete checkout process.
        </div>
        <div class="row">
            <PushCard
                v-for="(card, index) in abandonedCards"
                :key="index"
                class="col-lg-4"
                :cart-data="card"
            />
        </div>
        <div>
            <PushTable
                :data="data"
                @freshData="freshData"
            />
            <div class="add-reminder-container">
                <div>
                    <b-btn
                        class="btn blue-btn"
                        @click="createPushCart"
                    >
                        Add Reminder
                    </b-btn>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import PushCard from "@/components/push/abandoned-carts/PushCard";
import PushTable from "@/components/push/abandoned-carts/PushTable";
import push from "@/mixins/push/abandoned-carts.service"
import currencies from "@/data/currencies.json";
import shop from '@/mixins/shop.service';
import VideoButton from "@/components/header/VideoButton";

export default {
    name: "Index",
    components: {PushTable, PushCard, VideoButton},
    mixins: [push, shop],
    data() {
        return {
            data: null,
            currencies: currencies,
            shop: null,
            abandonedCards: [
                {
                    title: 'Revenue Recovered',
                    icon: 'fa fa-window-maximize',
                    salesCount: '0',
                    salesTitle: 'Sales'
                },
                {
                    title: 'Abandoned Carts',
                    icon: 'fa fa-users',
                    salesCount: '0',
                    salesTitle: 'Quantity'
                },
                {
                    title: 'Orders Recovered',
                    icon: 'fa fa-cube',
                    salesCount: '0',
                    salesTitle: 'Quantity'
                }
            ],
        }
    },
    computed: {
        getCurrencySign() {
            if (!this.currencies)
                return {
                    symbol: this.shop.payment_currency
                };
            return this.currencies[this.shop.payment_currency];
        }
    },
    created() {
        this.loadShop()
    },
    mounted() {
        this.freshData()
    },
    methods: {
        async createPushCart() {
            await this.createCart().catch((error) => {
                console.log(error)
            });
        },
        async loadShop() {
            this.shop = await this.getShop()
        },
        async freshData() {
            await this.getPushAbandonedCarts().then(res => {
                this.data = res;
                this.abandonedCards = [
                    {
                        title: 'Revenue Recovered',
                        icon: 'fa fa-window-maximize',
                        salesCount: this.getCurrencySign.symbol_native + this.data.total_revenue,
                        salesTitle: 'Sales'
                    },
                    {
                        title: 'Abandoned Carts',
                        icon: 'fa fa-users',
                        salesCount: this.data.total_carts,
                        salesTitle: 'Quantity'
                    },
                    {
                        title: 'Orders Recovered',
                        icon: 'fa fa-cube',
                        salesCount: this.data.total_orders,
                        salesTitle: 'Quantity'
                    }
                ]
            }).catch(error => {
                console.log(error)
            })
        }
    }
}
</script>

<style scoped>
.index__info {
    margin-bottom: 25px;
    width: 100%;
}
</style>
